#pragma once

#include <Irrlicht.h>
#include <IMeshLoader.h>
#include "CSkinnedMesh.h"
#include "clsPMDFile.h"
#include "clsVMDFile.h"

using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

class CPMDMeshFileLoader :
    public IMeshLoader
{
public:
    CPMDMeshFileLoader(ISceneManager *smgr, IVideoDriver *video);
    ~CPMDMeshFileLoader(void);

    // gq`FbN
    virtual bool isALoadableFileExtension(const c8* fileName) const;
    // f[^ǂݍŃAj[VbVԂ
    virtual IAnimatedMesh* createMesh(io::IReadFile* file);

protected:
    ISceneManager* SceneManager;
    IVideoDriver* VideoDriver;

    // {[Aj[VpbV
    CSkinnedMesh* AnimatedMesh;

    // PMDf[^p
    clsPMDFile *pmd;
    clsVMDFile *vmd;

    // }eAbV
    int materialCount;

    // o֐
    void init();
    bool load(io::IReadFile *file);
    void release();
    void createJointData();
    void createMaterialData();
};
